<?php

/***
 * PHP获取阿里云Access Token
 * Author 大潇
 * Date 2021-11-02 16:08
 * 仅修改下面AccessKeyId和AccessKeySecret即可使用
 * 请关注官网版本信息，若版本过期，请及时修改
 **/

$AccessKeyId="my_access_key_id"; #填写自己的AccessKeyId
$AccessKeySecret="my_access_key_secret"; #填写自己的AccessKeySecret
$date=date('Y-m-d',time());
$time="T".date("H:i:s",time()-60*60*8)."Z"; //UTC
$Timestamp=urlencode($date.$time);
$SignatureNonce=random(8).'-'.random(4).'-'.random(4).'-'.random(4).'-'.random(12);
$string="AccessKeyId=".$AccessKeyId."&Action=CreateToken&Format=JSON&RegionId=cn-shanghai&SignatureMethod=HMAC-SHA1&SignatureNonce=".$SignatureNonce."&SignatureVersion=1.0&Timestamp=".$Timestamp."&Version=2019-02-28";
$stringToSign="GET&".urlencode('/')."&".urlencode($string);
$signature = urlencode(hmac_sha1($stringToSign,$AccessKeySecret.'&'));
$api="http://nls-meta.cn-shanghai.aliyuncs.com/?Signature=".$signature."&".$string;
$content=file_get_contents($api);
$result=json_decode($content,true);
var_dump($result);

function hmac_sha1($str, $key) {
	$signature = "";
	if (function_exists('hash_hmac')) {
		$signature = base64_encode(hash_hmac("sha1", $str, $key, true));
	} else {
		$blocksize = 64;
		$hashfunc = 'sha1';
		if (strlen($key) > $blocksize) {
			$key = pack('H*', $hashfunc($key));
		}
		$key = str_pad($key, $blocksize, chr(0x00));
		$ipad = str_repeat(chr(0x36), $blocksize);
		$opad = str_repeat(chr(0x5c), $blocksize);
		$hmac = pack(
				'H*', $hashfunc(
						($key ^ $opad) . pack(
								'H*', $hashfunc(
										($key ^ $ipad) . $str
								)
						)
				)
		);
		$signature =base64_encode($hmac);
	}
	return $signature;
}
function random($num){
	$rand="";
	$string="abcdefghijklmnopqrstuvwxyz0123456789";
	for($i=0;$i<$num;$i++){
		$index=rand(0,strlen($string)-1);
		$rand.=$string[$index];
	}
	return $rand;
}

?>